#include <iostream>
#include <string>
#include <fstream>
#include <stack>
#include <stdexcept>
using namespace std;

void read_file(ifstream &f, string &input);
bool is_valid(const string &input);
bool is_pair(const char &c, const stack<char> &opening_brackets);
bool is_balanced(const string &input);
bool checker(ifstream &f) {
    string input;
    read_file(f, input);
    if (!is_valid(input)) {
        throw runtime_error("Invalid input");
    }
    return is_balanced(input);
}

int main() {
    ifstream f;
    if (checker(f)) {
        cout << "Brackets are balanced\n";
    } else {
        cout << "Brackets are not balanced\n";
    }
    return 0;
}

void read_file(ifstream &f, string &input) {
    cout << "Enter file name:\n";
    string file_name;
    cin >> file_name;

    f.open(file_name);
    while (!f.is_open()) {
        cout << "Please enter file name:\n";
        cin >> file_name;
        f.open(file_name);
    }

    string temp;
    while (f >> temp) {
        input += temp;
    }
    f.close();
}

bool is_valid(const string &input) {
    return (input.substr(0, 5) == "begin" && input.substr(input.size() - 3, 3) == "end");
}

bool is_pair(const char &c, const stack<char> &opening_brackets) {
    return ((c == ')' && opening_brackets.top() == '(') ||
            (c == ']' && opening_brackets.top() == '[') ||
            (c == '}' && opening_brackets.top() == '{'));
}

bool is_balanced(const string &input) {
    stack<char> opening_brackets;
    for (char c: input) {
        if (c == '(' || c == '[' || c == '{') {
            opening_brackets.push(c);
        } else if (c == ')' || c == ']' || c == '}') {
            if (!is_pair(c, opening_brackets)) return false;
            opening_brackets.pop();
        }
    }
    return opening_brackets.empty();
}