#include <vector>
#include <stdexcept>
#include <iostream>
using namespace std;

template<class T>
class Queue {
    vector<T> q;
    int front;
    int end;
public:
    Queue() : q(vector<T>()), front(0), end(-1) {}

    void enqueue(const T &rhs) {
        q.push_back(rhs);
        ++end;
    }

    void dequeue() {
        if (!is_empty()) {
            ++front;
            if (front > end) {
                // The queue is now empty
                // call clear() to reset the indices and clear the vector
                clear();
            }
        }
    }

    void clear() {
        front = 0;
        end = -1;
        q.clear();
    }

    int size() const {
        if (is_empty()) return 0;
        return end - front + 1;
    }

    bool is_empty() const {
        return (end == -1);
    }

    T top() const {
        if (is_empty()) {
            throw runtime_error("The queue is empty.");
        }
        return q[front];
    }

    T back() const {
        if (is_empty()) {
            throw runtime_error("The queue is empty.");
        }
        return q[end];
    }
};